'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DatePicker = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

var _utils = require('../utils.js');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _BasePicker2 = require('./BasePicker.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DatePicker = function (_BasePicker) {
  _inherits(DatePicker, _BasePicker);

  function DatePicker(props) {
    _classCallCheck(this, DatePicker);

    var _this = _possibleConstructorReturn(this, (DatePicker.__proto__ || Object.getPrototypeOf(DatePicker)).call(this, props));

    var initialValue = props.initialValue,
        dateFormat = props.dateFormat;

    var initialDate = initialValue ? (0, _moment2.default)(initialValue, dateFormat) : (0, _moment2.default)();
    _this.state = {
      activeDate: initialValue ? initialDate : null,
      dateToShow: initialDate,
      year: _this.props.startMode !== 'year' ? initialDate.year().toString() : '',
      month: ''
    };
    return _this;
  }

  _createClass(DatePicker, [{
    key: 'render',
    value: function render() {
      var rest = (0, _utils.getUnhandledProps)(DatePicker, this.props);

      return _react2.default.createElement(
        _semanticUiReact.Table,
        _extends({}, rest, {
          unstackable: true,
          celled: true,
          textAlign: 'center' }),
        this.getDatePickerContent()
      );
    }
  }]);

  return DatePicker;
}(_BasePicker2.BasePicker);

DatePicker.handledProps = ['dateFormat', 'initialValue', 'onDateChange', 'startMode'];


DatePicker.propTypes = {
  /** (event, data) => {} */
  onDateChange: _propTypes2.default.func,
  startMode: _propTypes2.default.oneOf(['year', 'month', 'day']),
  initialValue: _propTypes2.default.string,
  dateFormat: _propTypes2.default.string
};

DatePicker.defaultProps = {
  onDateChange: _utils.emptyFunction,
  startMode: 'day',
  dateFormat: 'DD-MM-YYYY'
};

exports.default = DatePicker;
exports.DatePicker = DatePicker;