'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DatesRangePicker = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

var _components = require('../components');

var _utils = require('../utils.js');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _BasePicker2 = require('./BasePicker.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DatesRangePicker = function (_BasePicker) {
  _inherits(DatesRangePicker, _BasePicker);

  function DatesRangePicker(props) {
    _classCallCheck(this, DatesRangePicker);

    var _this = _possibleConstructorReturn(this, (DatesRangePicker.__proto__ || Object.getPrototypeOf(DatesRangePicker)).call(this, props));

    _this.setDatesRange = function (event, data) {
      var onDatesRangeChange = _this.props.onDatesRangeChange;

      _this.setState(function (_ref) {
        var datesRange = _ref.datesRange;

        var newState = void 0;
        if (datesRange.start && datesRange.end) {
          newState = {
            datesRange: { start: null, end: null }
          };
          onDatesRangeChange(event, (0, _utils.cloneReplaceValue)(data, _this.getDatesRange()));
        } else if (datesRange.start && datesRange.start.isAfter(data.value)) {
          newState = {
            datesRange: { start: null, end: null }
          };
          onDatesRangeChange(event, (0, _utils.cloneReplaceValue)(data, _this.getDatesRange()));
        } else if (datesRange.start) {
          newState = {
            datesRange: { start: datesRange.start, end: data.value }
          };
          onDatesRangeChange(event, (0, _utils.cloneReplaceValue)(data, _this.getDatesRange({
            start: datesRange.start,
            end: data.value
          })));
        } else {
          newState = {
            datesRange: { start: data.value, end: datesRange.end }
          };
          onDatesRangeChange(event, (0, _utils.cloneReplaceValue)(data, _this.getDatesRange({
            start: data.value,
            end: datesRange.end
          })));
        }
        return newState;
      });
    };

    _this.getDatesRange = function (range) {
      var _this$props = _this.props,
          dateFormat = _this$props.dateFormat,
          divider = _this$props.divider;

      var _ref2 = range ? range : { start: null, end: null },
          start = _ref2.start,
          end = _ref2.end;

      var startStr = start && start.format ? start.format(dateFormat) : '. . .';
      var endStr = end && end.format ? end.format(dateFormat) : '. . .';
      return '' + startStr + divider + endStr;
    };

    _this.onDateClick = function (event, data) {
      _this.setDatesRange(event, data);
    };

    var initialDate = (0, _moment2.default)();
    _this.state = {
      dateToShow: initialDate,
      datesRange: { start: null, end: null }
    };
    return _this;
  }

  _createClass(DatesRangePicker, [{
    key: 'render',
    value: function render() {
      var rest = (0, _utils.getUnhandledProps)(DatesRangePicker, this.props);

      return _react2.default.createElement(
        _semanticUiReact.Table,
        _extends({}, rest, {
          unstackable: true,
          celled: true,
          textAlign: 'center' }),
        _react2.default.createElement(_components.PickerHeader, {
          onNextBtnClick: this.showNextMonth,
          onPrevBtnClick: this.showPrevMonth,
          activeDate: this.state.dateToShow,
          activeDatesRange: this.state.datesRange,
          showWeeks: true,
          width: '7' }),
        _react2.default.createElement(_components.DatePickerComponent, {
          datesRange: this.state.datesRange,
          onDateClick: this.onDateClick,
          showedMonth: this.state.dateToShow })
      );
    }
  }]);

  return DatesRangePicker;
}(_BasePicker2.BasePicker);

DatesRangePicker.handledProps = ['dateFormat', 'divider', 'onDatesRangeChange'];


DatesRangePicker.propTypes = {
  /** (event, data) => {} */
  onDatesRangeChange: _propTypes2.default.func,
  /** Date formatting string.
   * Anything that that can be passed to ``moment().format``.
   */
  dateFormat: _propTypes2.default.string,
  /** Characters that are used to divide dates in string. */
  divider: _propTypes2.default.string
};

DatesRangePicker.defaultProps = {
  onDatesRangeChange: _utils.emptyFunction,
  dateFormat: 'DD.MM.YY',
  divider: ' - '
};

exports.default = DatesRangePicker;
exports.DatesRangePicker = DatesRangePicker;